package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserAgreement;
import com.izouma.awesomeadmin.service.UserAgreementService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/userAgreement")
@RequiresAuthentication
public class UserAgreementController {

    @Autowired
    private UserAgreementService userAgreementService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserAgreement record) {
        List<UserAgreement> pp = userAgreementService.getUserAgreementList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getUserAgreement", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserAgreement(@RequestParam(required = false, value = "id") String id) {
        UserAgreement data = userAgreementService.getUserAgreementById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserAgreement record) {
        UserAgreement data = userAgreementService.getUserAgreement(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserAgreement record) {
        Map<String, Object> result = new HashMap<>();

        List<UserAgreement> pp =userAgreementService.getUserAgreementByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserAgreement record) {
        boolean num = userAgreementService.createUserAgreement(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserAgreement(UserAgreement record) {
        boolean num = userAgreementService.updateUserAgreement(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserAgreement(UserAgreement record) {

        boolean num = userAgreementService.deleteUserAgreement(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserAgreement record) throws Exception {

    List<UserAgreement> userAgreements = userAgreementService.getUserAgreementList(record);


        String sheetName = "user_agreement";
        String titleName = "用户协议数据表";
        String fileName = "用户协议表";
        int columnNumber = 8;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "协议" ,   "备注"  };
        String[][] dataList = new String[userAgreements.size()][8];

        for (int i = 0; i < userAgreements.size(); i++) {

                        dataList[i][0] = String.valueOf(userAgreements.get(i).getId());
                        dataList[i][1] = String.valueOf(userAgreements.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(userAgreements.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(userAgreements.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(userAgreements.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(userAgreements.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(userAgreements.get(i).getAgreement());
                        dataList[i][7] = String.valueOf(userAgreements.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

